Package: OmicsMLRepoR
Type: Package
Title: Search harmonized metadata created under the OmicsMLRepo project
Version: 1.6.0
Date: 2026-3-19
Authors@R: 
    c(person(given = "Sehyun",
             family = "Oh",
             role = c("aut", "cre"),
             email = "shbrief@gmail.com",
             comment = c(ORCID = "0000-0002-9490-3061")),
      person(given = "Kaelyn",
             family = "Long",
             email = "krlong586@gmail.com",
             role = "aut"))
Description: This package provides functions to browse the harmonized metadata for large omics databases. This package also supports data navigation if the metadata incorporates ontology. 
Depends: R (>= 4.4.0)
Imports: dplyr, stringr, rols, tidyr, methods, stats, tibble,
        data.tree, jsonlite, plyr, BiocFileCache, readr, DiagrammeR,
        rlang, lubridate
Suggests: arrow, knitr, BiocStyle, curatedMetagenomicData, testthat (>=
        3.0.0), cBioPortalData
License: Artistic-2.0
biocViews: Software, Infrastructure, DataRepresentation
Encoding: UTF-8
RoxygenNote: 7.3.3
VignetteBuilder: knitr
URL: https://github.com/shbrief/OmicsMLRepoR
BugReports: https://github.com/shbrief/OmicsMLRepoR/issues
git_url: https://git.bioconductor.org/packages/OmicsMLRepoR
git_branch: RELEASE_3_23
git_last_commit: 75e8efd
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:40:39 UTC; biocbuild
Author: Sehyun Oh [aut, cre] (ORCID: <https://orcid.org/0000-0002-9490-3061>),
  Kaelyn Long [aut]
Maintainer: Sehyun Oh <shbrief@gmail.com>

## Improved findability and AI/ML-readiness of non-omics metadata

The *OmicsMLRepo project* aims to harmonize and standardize clinical metadata 
from public Omics data resources. Currently, [curatedMetagenomicData][] and the 
part of [cBioPortalData][]'s metadata are processed under [this project][].

[curatedMetagenomicData]: https://www.bioconductor.org/packages/release/data/experiment/html/curatedMetagenomicData.html
[cBioPortalData]: https://www.bioconductor.org/packages/release/bioc/html/cBioPortalData.html
[this project]: https://github.com/waldronlab/OmicsMLRepoData 

### Installation
```
if (!require("BiocManager"))
    install.packages("BiocManager")

BiocManager::install("OmicsMLRepoR")
```

### Harmonized metadata
The harmonized metadata are featured with the following standards:

<img src="https://raw.githubusercontent.com/shbrief/OmicsMLRepoR/master/vignettes/4C_Diagram.png" width="60%" height="60%"/>

### Rubust data searching
*OmicsMLRepoR* is the R package to facilitate the easy access and search of 
the harmonized metadata produced under the OmicsMLRepo project. Thanks to the
ontology, metadata searching in OmicsMLRepoR is much more robust - your query 
automatically includes [OLS][]-defined _**synonyms**_ (Example B) and all the 
_**descendants**_ (Example C) from the ontology tree.

[OLS]: https://www.ebi.ac.uk/ols4

##### A. Before harmonization (original metadata, `sampleMetadata`)
```
> library(curatedMetagenomicData)
> nrow(sampleMetadata |> filter(study_condition == "CRC"))
[1] 701
> nrow(sampleMetadata |> filter(disease == "CRC"))
[1] 625
> nrow(sampleMetadata |> filter(study_condition == "crc"))
[1] 0
> nrow(sampleMetadata |> filter(study_condition == "Colorectal Carcinoma"))
[1] 0
> nrow(sampleMetadata |> filter(study_condition == "Colorectal Cancer"))
[1] 0
> nrow(sampleMetadata |> filter(study_condition == "Intestinal Disorder"))
[1] 0
```

##### B. Harmonized metadata (`cmd`)
```
> library(OmicsMLRepoR)
> cmd <- getMetadata("cMD")
> nrow(cmd |> tree_filter(disease, "CRC"))
[1] 701
> nrow(cmd |> tree_filter(disease, "crc")) # not case-sensitive
[1] 701
> nrow(cmd |> tree_filter(disease, "Colorectal Carcinoma")) # synonym
[1] 701
> nrow(cmd |> tree_filter(disease, "Colorectal Cancer")) # synonym
[1] 701
```

##### C. Search descendants of the query in harmonized metadata
```
> onto_res <- cmd |> tree_filter(disease, "Intestinal Disorder")
> unique(onto_res$disease)
 [1] "Crohn Disease;Schizophrenia"                                                           
 [2] "Colorectal Carcinoma;Hepatic Steatosis;Hypertension;Carcinoma"                         
 [3] "Colorectal Carcinoma;Carcinoma"                                                        
 [4] "Colorectal Carcinoma;Type 2 Diabetes Mellitus;Hepatic Steatosis;Hypertension;Carcinoma"
 [5] "Colorectal Carcinoma;Hypertension;Carcinoma"                                           
 [6] "Colorectal Carcinoma;Hepatic Steatosis;Carcinoma"                                      
 [7] "Colorectal Carcinoma;Type 2 Diabetes Mellitus;Hypertension;Carcinoma"                  
 [8] "Colorectal Carcinoma;Adenocarcinoma"                                                   
 [9] "Inflammatory Bowel Disease;Crohn Disease"                                              
[10] "Inflammatory Bowel Disease;Ulcerative Colitis"                                         
[11] "Colorectal Carcinoma"                                                                  
[12] "Cytomegaloviral Infection;Celiac Disease;Gestational Diabetes"                         
[13] "Type 1 Diabetes Mellitus;Celiac Disease;Irritable Bowel Syndrome"                      
[14] "Inflammatory Bowel Disease"                                                            
[15] "Inflammatory Bowel Disease;Fecal Microbiota Transplantation"                           
[16] "Melanoma;Colitis"                                                                      
[17] "Inflammatory Bowel Disease;Anorectal Fistula;Crohn Disease"                            
[18] "Colorectal Carcinoma;Hypercholesterolemia;Adenocarcinoma"                              
[19] "Colorectal Carcinoma;Hypertension;Adenocarcinoma"                                      
[20] "Colorectal Carcinoma;Hypercholesterolemia;Hypertension;Adenocarcinoma"                 
[21] "Colorectal Carcinoma;Metastatic Malignant Neoplasm;Adenocarcinoma"                     
[22] "Inflammatory Bowel Disease;Colitis"                                                    
[23] "Colorectal Carcinoma;Type 2 Diabetes Mellitus;Carcinoma"                               
[24] "Adenoma;Small Intestinal Adenoma"                                                      
[25] "Adenoma;Colorectal Adenoma"       
```

#' Query Ontology Lookup Service (OLS)
#' 
#' Extract identical or similar ontology terms across different ontologies
#'
#' @importFrom rols OlsSearch olsSearch
#' @importFrom methods as
#' @importFrom dplyr filter
#' @importFrom tibble as_tibble
#'
#' @param query A character (1) containing the search query, either a term
#' label or term id.
#' @param ontology A character vector defining the ontology to be queried. 
#' Default is the empty character, to search all ontologies.
#' @param exact A logical (1) defining if OLS search is restricted to exact
#' matches. Defaults is `FALSE`. 
#' @param rows An integer (1) defining the number of query returns. 
#' Default is 20L. Maximum number of values returned by the server is 1000.
#' 
#' @return A tibble containing ontology term label and description
#'
#' @examples
#' getOntoInfo("NCIT:C4872")
#' getOntoInfo("NCIT:C4872", ontology = c("EFO", "MONDO"))
#' getOntoInfo("Skin Infection")
#' getOntoInfo("Sitagliptin", ontology = c("Chebi", "apple"))
#' 
#' ## Multiple query values
#' getOntoInfo("plasma,membrane")
#' getOntoInfo(c("plasma", "membrane"))
#'
#' @export
getOntoInfo <- function(query, 
                        ontology = "",
                        exact = FALSE,
                        rows = 20) {
    qry <- OlsSearch(q = query, ontology = ontology, rows = rows, exact = exact)
    qry <- olsSearch(qry)
    qdrf <- as(qry, "data.frame")
    qdrf <- tibble::as_tibble(qdrf)
    qdrf$description <- as.character(qdrf$description)
    return(qdrf)
}

## cBioPortal `curated_treatment_*` tables
dir <- "~/OmicsMLRepo/OmicsMLRepoData"
dataDir <- file.path(dir, "cBioPortalData/cBioPortal_treatment/data")
curated <- list.files(dataDir)
curatedTrtObj <- gsub(".rds", "", curated)
for (i in seq_along(curated)) {
    res <- readRDS(file.path(dataDir, curated[i]))
    assign(curatedTrtObj[i], res)
}

## All the column names from 4 `curated_treatment_*` data tables
columns <- sapply(curatedTrtObj, function(x) {colnames(get(x))})

extDir <- file.path(dir, "inst/extdata")
ecols <- columns[grep("curated_treatment", names(columns))] %>% 
    unlist %>% unique %>% as.character %>% .[-1]
write.table(ecols, file.path(extDir, "treatment_columns.txt"), 
            row.names = FALSE, col.names = FALSE, quote = FALSE)

#' Groups ontology terms by the child term of a provided "parent" they fall
#' under
#' 
#' @import rols
#' @import stringr
#'
#' @param parent Character; Term to use as parent of summarized children
#' @param descendants Character vector; Terms to summarize as children of parent
#' @param ontology Character; Ontology database ID
#' @return A dataframe containing the descendants summarized into groups. Name
#' of each group is the child of the parent that the descendants are grouped
#' under. Both IDs and labels of the ontology terms are provided.
#' 
#' @examples
#' ontology <- "ncit"
#' parent <- "NCIT:C17049"
#' descendants <- c("NCIT:C44265", "NCIT:C77811", "NCIT:C43856",
#'                  "NCIT:C43672", "NCIT:C2991", "NCIT:C43860")
#' ontoSummarize(parent, descendants, ontology)
#' 
#' @export
ontoSummarize <- function(parent, descendants, ontology) {
    # Initialize ontology
    ontob <- olsOntology(ontology)
    
    # Get children of parent to establish groups
    pterm <- olsTerm(ontob, parent)
    pchildren <- names(termLabel(children(pterm)))
    
    # Get ancestors of all descendants
    # FIX: was termLabel(ontob, x), should be olsTerm(ontob, x)
    dancs <- sapply(descendants, 
                    function(x) names(termLabel(ancestors(olsTerm(ontob, x)))),
                    simplify = FALSE,
                    USE.NAMES = TRUE)
    
    dall <- mapply(c, names(dancs), dancs)
    
    # Group descendants by children of parents
    dgroups <- sapply(dall, function(x) x[which(x %in% pchildren)],
                      simplify = FALSE,
                      USE.NAMES = TRUE)
    dgroups[lengths(dgroups) == 0] <- paste0("Not a descendant of ", parent)
    
    finalgroups <- split(names(dgroups), unname(unlist(dgroups)))
    collapse_groups <- unlist(unname(lapply(finalgroups, function(x)
        paste(x, collapse = ";"))))
    
    ids_to_convert <- unique(c(names(finalgroups), unlist(unname(finalgroups))))
    extract_ids <- str_match(ids_to_convert, paste0(toupper(ontology), ":.*$"))
    extract_ids <- extract_ids[!is.na(extract_ids)]
    termnames <- unlist(lapply(extract_ids, function(x) termLabel(olsTerm(ontob, x))))
    names(termnames) <- extract_ids
    group_names <- str_replace_all(names(finalgroups), termnames)
    original_names <- str_replace_all(collapse_groups, termnames)
    
    finalframe <- data.frame(group_ids = names(finalgroups),
                             group_names = group_names,
                             original_ids = collapse_groups,
                             original_names = original_names)
    
    return(finalframe)
}

# Formats a multi-line string as it it were on one line
#
# @importFrom stringr str_remove_all
# @param text Any character vector
# @return The same character vector with newlines and subsequent 
# whites-paces removed
#
# @keywords internal
single_line_str <- function(text) {
    stringr::str_remove_all(text, r"(\n\s*)")
}


# Check that a character doesn't match any non-letter
# @param x A character(1).
letters_only <- function(x) !grepl("[^A-Za-z]", x)


# Check that a character doesn't match any non-number
# @param x A character(1).
numbers_only <- function(x) !grepl("\\D", x)


#' Extract ontology from the ontology term ids
#'
#' @param terms A character vector
#' @param delim A character. Delimiter between ontology and its id.
#' Default is `:`.
#' 
#' @return A character vector containing the ontology names of the input 
#' `terms`. The length of this is same as the `terms` input. 
#'
#' @examples
#' terms <- c("HP:0001824", "MONDO:0010200", "NCIT:C122328", "4471000175100")
#' get_ontologies(terms = terms)
#'
#' @export
get_ontologies <- function(terms, delim = ":") {
    
    ontologies <- c()
    for (i in seq_along(terms)) {
        onto <- strsplit(terms[i], delim)[[1]][1]
        isSNOMED <- letters_only(onto)
        if (isFALSE(isSNOMED)) {onto <- "SNOMED"}
        ontologies[i] <- onto
    }
    return(ontologies)
}


#' Custom function to merge vectors 
#' 
#' This function is designed for a group of, collapsible metadata attributes
#' (e.g., 'biomarker' for curatedMetagenomicData).
#' 
#' @importFrom stats setNames
#' 
#' @param base A character. A space-holder version of the key:value 
#' concatenates (e.g., `column1:NA;column2:NA;column3:NA`)
#' @param update A character. The target string to be compared and filled with 
#' `base` if there is missing pairs. (e.g., `column1:value1;column3:value3`) 
#' @param sep A character string to separate the column name and value. 
#' Default is `:`
#' @param delim A character string to separate the column:value pairs. 
#' Default is `;`
#' 
#' @return A character updated the target string (`update`) to follow the
#' reference string (`base`).
#' 
#' @examples
#' x <- "color:NA;shape:NA;size:NA"
#' y <- "color:green;size:large"
#' merge_vectors(x, y)
#' 
#' @export
merge_vectors <- function(base, update, sep = ":", delim = ";") {
    
    ## Split the vectors into key-value pairs
    base_pairs <- strsplit(strsplit(base, delim)[[1]], sep)
    update_pairs <- strsplit(strsplit(update, delim)[[1]], sep)
    
    ## Create a dictionary from base pairs
    base_dict <- setNames(vapply(base_pairs, 
                                 function(x) ifelse(length(x) == 2, x[2], NA),
                                 character(1)), 
                          vapply(base_pairs, 
                                 function(x) ifelse(length(x) == 2, x[1], NA),
                                 character(1)))
    
    ## Update the base dictionary with values from update pairs
    for (pair in update_pairs) {
        if (length(pair) == 2) {
            base_dict[pair[1]] <- pair[2]
        }
    }
    
    ## Recreate the merged vector
    merged_vector <- paste(names(base_dict), base_dict, sep = sep)  
    res <- paste0(merged_vector, collapse = delim)
    return(res)
}


## Get target database information
.getTargetDB <- function(meta) {
    targetDB <- unique(meta$package)
    if (is.null(targetDB)) {message("`meta` table doesn't include `targetDB` information.")}
    return(targetDB)
}


# Get delimiter
# @importFrom utils read.csv

.getDelimiter <- function(meta, targetCol, delim = NULL) {
    
    targetDB <- .getTargetDB(meta)
    
    ## Extract the delimiter
    if (is.null(delim) & is.null(targetDB)) {
        stop("Provide the `delim` input")
    } else if (is.null(delim)) {
        ## Load data dictionary
        dir <- system.file("extdata", package = "OmicsMLRepoR")
        fname <- paste0(targetDB, "_data_dictionary.csv")
        dd <- read.csv(file.path(dir, fname), header = TRUE)
        
        ## Get the delimiter(s)
        colInd <- which(dd$ColName %in% targetCol)
        delim <- dd$Delimiter[colInd] %>% unique
    }
    
    if (!length(delim)) {stop("The targetCol using different delimiter. Process one at a time.")}

    return(delim)
}


# Get separater
# @importFrom utils read.csv

.getSeparater <- function(meta, targetCol) {
    
    targetDB <- .getTargetDB(meta)
    
    ## Load data dictionary
    dir <- system.file("extdata", package = "OmicsMLRepoR")
    fname <- paste0(targetDB, "_data_dictionary.csv")
    dd <- read.csv(file.path(dir, fname), header = TRUE)
    
    ## Get the separater
    colInd <- which(dd$ColName %in% targetCol)
    seperater <- dd$Separater[colInd] %>% unique
    
    if (length(seperater) > 1) {
        stop("The targetCol using different separater. Process one at a time.")
    }
    
    return(seperater)
}

# Get ontology database(s)
# @importFrom utils read.csv

.getOntos <- function(meta, targetCol) {
    
    targetDB <- .getTargetDB(meta)
    
    ## Extract the delimiter
    ## Load data dictionary
    dir <- system.file("extdata", package = "OmicsMLRepoR")
    fname <- paste0(targetDB, "_data_dictionary.csv")
    dd <- read.csv(file.path(dir, fname), header = TRUE)
    
    ## Get the ontology names
    colInd <- which(dd$ColName %in% targetCol)
    # ontos <- dd$OntologyDB[colInd] %>% unique %>% .[!is.na(.)]
    # split_ontos <- unlist(strsplit(ontos, "\\|"))
    split_ontos <- strsplit(dd$DynamicEnum[colInd], ";") %>% unlist %>% get_ontologies(., ":")

    if (is.null(split_ontos)) {stop("The targetCol do not have listed ontology databases.")}
    
    return(split_ontos)
}

## Convert "NA" to `NA`
.charToLogicNA <- function(tb) {
    timeVar <- sapply(tb, lubridate::is.POSIXct)
    if (any(timeVar)) {
        ## Handle `POSIXct` separately
        timeInd <- which(timeVar)
        tb_sub <- tb[,-timeInd]
        tb_sub[tb_sub == "NA"] <- NA
        res <- cbind(tb_sub, tb[timeInd])
    } else {
        tb[tb == "NA"] <- NA
        res <- tb
    }
    return(res)
}

## Include associated attributes
.getAssociatedAttr <- function(dat, attrName) {
    attrName_onto <- c(attrName, paste0(attrName, "_ontology_term_id"))
    res_onto <- intersect(attrName_onto, colnames(dat))
    
    attrName_unit <- c(attrName, paste0(attrName, "_unit"))
    res_unit <- intersect(attrName_unit, colnames(dat))
    
    resAll <- c(res_onto, res_unit) %>% unique
    return(resAll)
}

test_that("get_ontologies function", {
    terms <- c("HP:0001824", "MONDO:0010200", "NCIT:C122328", "86743009")
    res <- get_ontologies(terms)
    expect_equal(res, c("HP", "MONDO", "NCIT", "SNOMED"))
})

test_that("merge_vectors function", {
    x <- "color:NA;shape:NA;size:NA"
    y <- "color:green;size:large"
    res <- merge_vectors(x, y)
    expect_equal(res, "color:green;shape:NA;size:large")
})

library(rols)

test_that("ontoTreePlot function works correctly", {

    test_term <- "NCIT:C2852"
    test_plot <- ontoTreePlot(test_term)
    
    # Check if the function produces output (which should be a plot)
    expect_true(all(class(test_plot) == c("grViz", "htmlwidget")))
    
    # Check if the Term object is created correctly
    ontob <- olsOntology(get_ontologies(test_term))
    expect_s4_class(olsTerm(ontob, test_term), "olsTerm")
    
    # Check if the JSON tree is retrieved and parsed correctly
    cur_trm <- olsTerm(ontob, test_term)
    jstree <- cur_trm@links$jstree$href
    expect_true(is.data.frame(jsonlite::fromJSON(jstree)))
    
})

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(comment = "#>", 
                      collapse = TRUE, 
                      message = FALSE, 
                      warning = FALSE)

## -----------------------------------------------------------------------------
suppressPackageStartupMessages({
    library(OmicsMLRepoR)
    library(dplyr)
    library(curatedMetagenomicData)
    library(cBioPortalData)
})

## -----------------------------------------------------------------------------
cmd <- getMetadata("cMD")
cmd

## -----------------------------------------------------------------------------
cbio <- getMetadata("cBioPortal")
cbio

## ----echo=FALSE---------------------------------------------------------------
colnames(cmd)[grep("_ontology_term_id", colnames(cmd))] %>% 
    gsub("_ontology_term_id", "", .)

## ----robust_browsing----------------------------------------------------------
## Information spread out in two different columns
nrow(sampleMetadata |> filter(study_condition == "CRC"))
nrow(sampleMetadata |> filter(disease == "CRC"))

## Case sensitive
nrow(sampleMetadata |> filter(study_condition == "CRC"))
nrow(sampleMetadata |> filter(study_condition == "crc"))

## Synonyms not covered
nrow(sampleMetadata |> filter(study_condition == "Colorectal Carcinoma"))
nrow(sampleMetadata |> filter(study_condition == "Colorectal Cancer"))

## ----not_case_sensitive-------------------------------------------------------
nrow(cmd |> tree_filter(disease, "Colorectal Carcinoma"))
nrow(cmd |> tree_filter(disease, "colorectal carcinoma"))

## ----include_synonyms---------------------------------------------------------
syn_res1 <- cmd |> tree_filter(disease, "CRC")
syn_res2 <- cmd |> tree_filter(disease, "Colorectal Cancer")
syn_res3 <- cmd |> tree_filter(disease, "Colorectal Carcinoma")

nrow(syn_res1)
nrow(syn_res2)
nrow(syn_res3)

## ----sanity_check-------------------------------------------------------------
unique(syn_res1$disease)
unique(syn_res2$disease)
unique(syn_res3$disease)

## ----descendant_search--------------------------------------------------------
onto_res <- cmd |> tree_filter(disease, "Intestinal Disorder")
unique(onto_res$disease)

## ----multiple_searching_terms-------------------------------------------------
res_or <- cmd %>% tree_filter(disease, c("migraine", "diabetes"), "OR")

## ----different_filter_logic---------------------------------------------------
res_and <- cmd %>% tree_filter(disease, c("migraine", "diabetes"), "AND")
res_not <- cmd %>% tree_filter(disease, c("migraine", "diabetes"), "NOT")

## ----example------------------------------------------------------------------
res_or_below30 <- cmd %>% 
    filter(age_years < 30) %>%
    tree_filter(disease, c("migraine", "diabetes"))

## -----------------------------------------------------------------------------
cmd_biomarker <- cmd %>% 
    filter(!is.na(biomarker)) %>% 
    select(curation_id, biomarker)
wtb <- getWideMetaTb(cmd_biomarker, "biomarker")
head(wtb)

## -----------------------------------------------------------------------------
ltb <- getLongMetaTb(cmd, targetCol = "target_condition")
dim(cmd)
dim(ltb)

## ----debug_needed, echo=FALSE-------------------------------------------------
cmd_sub <- tree_filter(cmd, target_condition, "Alzheimer's disease")

## -----------------------------------------------------------------------------
cmd_dat <- cmd %>%
    tree_filter(col = "disease", "Type 2 Diabetes Mellitus") %>%
    filter(sex == "Female") %>%
    filter(age_group == "Elderly") %>%
    returnSamples("relative_abundance", rownames = "short")

## -----------------------------------------------------------------------------
cbio_sub <- cbio %>%
    getLongMetaTb("treatment_name", "<;>") %>%
    filter(treatment_name == "Fluorouracil") %>%
    filter(age_at_diagnosis > 50) %>%
    filter(sex == "Female") %>%
    getShortMetaTb(idCols = "curation_id", targetCol = "treatment_name")

dim(cbio_sub)
studies <- unique(cbio_sub$studyId)
studies

## ----echo=FALSE, eval=FALSE---------------------------------------------------
# cbio_api <- cBioPortal()
# resAll <- as.list(vector(length = length(studies)))
# 
# for (i in seq_along(studies)) {
#     study <- studies[i]
#     samples <- cbio_sub %>%
#         filter(studyId == study) %>%
#         pull(sampleId)
# 
#     res <- cBioPortalData(
#         api = cbio_api,
#         by = "hugoGeneSymbol",
#         studyId = study,
#         sampleIds = samples,
#         genePanelId = "IMPACT341"
#     )
# 
#     resAll[[i]] <- res
# }

## -----------------------------------------------------------------------------
sessionInfo()

#' Expands metadata with multiple values belong to a same attribute
#'
#' Same as the `getWideMetaTb` function, this function accepts single
#' target column (`targetCol`). The target columns (and linked, accessory
#' columns) should have the same number of elements separated by the `delim`, 
#' and the multiple values for each column belongs to the same column/
#' attribute/field, i.e., no additional column name is required/provided.
#' 
#' @importFrom tidyr separate_longer_delim 
#' 
#' @param meta A data frame. Each column (and associated `ontology_term_id`
#' column) should use the same delimiter to separate multiple, same-numbered
#' values.
#' @param targetCol A character. The column name(s) to expand if present. 
#' If multiple columns are specified here, they should be separated by 
#' the `sep` and the column name and its value should be separated by the 
#' provided `delim`.
#' @param delim Optional. A character (1) of a delimiter used to separate 
#' multiple values in the metadata table. 
#' 
#' @return A data frame of metadata expanded so that each individual treatment 
#' has its own row.
#' 
#' @examples
#' data(mini_cmd)
#' lmeta <- getLongMetaTb(mini_cmd, "hla")
#' dim(mini_cmd) 
#' dim(lmeta) 
#' 
#' data(mini_cmd2)
#' lmeta2 <- getLongMetaTb(mini_cmd2, "target_condition")
#' head(lmeta2, 3)
#' 
#' data(mini_cbio)
#' trt_cols <- grep("^treatment_", colnames(mini_cbio), value = TRUE)
#' lmeta3 <- getLongMetaTb(mini_cbio, targetCol = trt_cols)
#' 
#' short_tb <- data.frame(
#'     ind = c("A", "B", "C", "D", "E"),
#'     aval = c("cat;dog", "chicken", "horse", "frog;pig", "snake"),
#'     cval = c(1, NA, 3, 4, 5),
#'     bval = c("red;blue", "yellow", "NA", "green;NA", "brown"))
#'     
#' getLongMetaTb(short_tb, c("aval", "bval"), delim = ";")
#' 
#' @export
getLongMetaTb <- function(meta, 
                          targetCol = NULL, 
                          delim = NULL) {
    
    ## Include associated attributes (e.g., `_ontology_term_id` or `_unit`) if exist
    targetCol <- .getAssociatedAttr(meta, targetCol)
    
    ## Extract the delimiter
    delim <- .getDelimiter(meta, targetCol, delim)
    
    ## Expand data frame
    res <- tidyr::separate_longer_delim(data = meta,
                                        cols = any_of(targetCol),
                                        delim = delim)
    
    ## Convert "NA" to `NA`
    res_all <- .charToLogicNA(res)
    
    return(res_all)
}

#' Create individual columns for different attributes stored in one column
#' 
#' The values stored in one column should include their potential column
#' names to use this function. 
#' 
#' @importFrom stats na.omit
#' 
#' @param meta A data frame.
#' @param targetCol A character. The column name(s) to expand if present. 
#' If multiple columns are specified here, they should be separated by 
#' the `sep` and the column name and its value should be separated by the 
#' provided `delim`.
#' @param sep A character (1). Delimiter used to concatenate column name 
#' and its value. Default is double colons, `:`.
#' @param delim A character(1). Separator used between values. Default `<;>`.
#' @param remove If `TRUE`, remove input columns from output data frame.
#'
#' @return A data frame where the contents under `targetCol` is split into
#' individual columns in an alphabetical order. Data type of the expanded 
#' columns is all character.
#' 
#' @examples
#' ## Narrow-table example
#' narrow_tb <- data.frame(fruit = c("apple", "banana", "pear", "watermelon", 
#'                                   "grape"), 
#'                         feature = c("color:red;shape:round;size:medium", 
#'                                     "color:yellow;shape:long;size:medium",
#'                                     "color:brown;shape:NA;size:NA",
#'                                     "color:green;shape:round;size:large",
#'                                     "color:purple;shape:NA;size:small"))
#' getWideMetaTb(narrow_tb, targetCol = "feature", sep = ":", delim = ";")
#' 
#' ## Narrow-table example with missing columns
#' narrow_tb2 <- data.frame(fruit = c("apple", "banana", "pear", 
#'                                    "watermelon", "grape"), 
#'                         feature = c("color:red;shape:round;size:medium", 
#'                                     "color:yellow;shape:long;size:medium",
#'                                     NA,
#'                                     "color:green;size:large",
#'                                     "color:purple;shape:NA;size:small"))
#' getWideMetaTb(narrow_tb2, targetCol = "feature", sep = ":", delim = ";")
#' 
#' ## Subset of cMD metadata
#' data(mini_cmd3)
#' wtb <- getWideMetaTb(mini_cmd3, targetCol = "probing_pocket_depth")
#' head(wtb)
#' 
#' @export
getWideMetaTb <- function(meta, 
                          targetCol = NULL, 
                          sep = ":",
                          delim = "<;>",
                          remove = TRUE) {
    
    ## Get columns and values from targetCol
    embeddedCols <- meta[[targetCol]] %>%
        strsplit(split = delim) 
    
    embeddedColNames <- embeddedCols %>%
        lapply(function(x) {strsplit(x, split = sep)}) %>%
        lapply(function(x) {unlist(lapply(x, function(y) {y[1]}))})
    
    embeddedColValues <- embeddedCols %>%
        lapply(function(x) {strsplit(x, split = sep)}) %>%
        lapply(function(x) {unlist(lapply(x, function(y) {y[2]}))})
    
    ## The number of elements in each row
    embeddedColNums <- vapply(embeddedCols, length, integer(1)) 
    
    ## Alphabetical ordering of all the unique columns
    newColNames <- unique(unlist(embeddedColNames)) %>% na.omit %>% sort 
    base <- paste0(newColNames, sep, "NA") %>%
        paste0(collapse = delim)
    
    ## Rows to be filled with TRUE
    rowToFillTrue <- which(vapply(embeddedCols,
                                  function(x) {if (!anyNA(x)) {
                                      any(!grepl(sep, x))
                                      } else {FALSE}},
                                  FUN.VALUE = logical(1)))
    
    ## Add TRUE to indicator columns
    for (ind in rowToFillTrue) {
        vals <- meta[[ind, targetCol]] %>%
                strsplit(split = delim) %>%
                unlist()
        add_true <- which(!grepl(sep, vals))
        
        for (i in add_true) {
            vals[i] <- paste0(vals[i], ":TRUE")
        }
        
        updatedVal <- paste(vals, collapse = delim)
        meta[ind, targetCol] <- updatedVal
    }
    
    ## Rows to be consolidated
    colToCombine <- which(vapply(embeddedColNames,
                                 function(x) length(unique(table(x))) > 1, 
                                 FUN.VALUE = logical(1)))
    
    ## Consolidate values of repeated columns
    for (ind in colToCombine) {
        sep_cols <- meta[[ind, targetCol]] %>%
            strsplit(split = delim) %>% 
            unlist() %>% 
            str_extract(".*(?=:)")
        
        sep_vals <- meta[[ind, targetCol]] %>%
            strsplit(split = delim) %>% 
            unlist() %>% 
            str_extract("(?<=:).*")
        
        groups <- split(sep_vals, sep_cols) %>% 
            lapply(function(x) paste(unique(x),
                                     collapse = "<temporary_separator>"))
        
        meta[[ind, targetCol]] <- paste(names(groups), groups,
                                        sep = sep, collapse = delim)
    }
    
    ## Rows need to be filled with NAs
    rowToFillInd <- which(vapply(embeddedColNames, 
                                 function(x) any(!newColNames %in% x),
                                 FUN.VALUE = logical(1)))
    
    ## Add NA-placeholder for non-existing columns 
    for (ind in rowToFillInd) {
        updatedVal <- merge_vectors(base, 
                                    update = meta[[ind, targetCol]], 
                                    sep = sep, delim = delim)
        meta[ind, targetCol] <- updatedVal
    }
    
    ## Confirm column order
    meta[targetCol] <- meta[[targetCol]] %>%
        strsplit(delim) %>% 
        lapply(sort) %>% 
        lapply(function(x) paste(x, collapse = delim)) %>%
        unlist
    
    res <- meta %>%
        separate_wider_delim(targetCol,
                             delim = delim,
                             names = newColNames,
                             cols_remove = remove)
    
    ## Remove column names in values and <temporary_separator>
    for (newColName in newColNames) {
        res[newColName] <- gsub(paste0(newColName, sep), 
                                "", res[[newColName]], fixed = TRUE)
        
        res[newColName] <- gsub("<temporary_separator>", delim,
                                res[[newColName]], fixed = TRUE)
    } 

    ## Convert "NA" to `NA`
    res_all <- .charToLogicNA(res)
    
    return(res_all)
}


#' Manipulate metadata into a spread format
#' 
#' This function speads gout multiple values per attribute (‘multi-valued’ 
#' attribute) or multiple features under a single generic attribute 
#' (‘composite’ attribute). Multi-valued attribute will return 'long' table, 
#' while composite attribute will return 'wide' table. 
#' 
#' @param meta A data frame. Harmonized metadata available through the
#' OmicsMLRepoR package. It should have the `package` column.
#' @param targetCol A character. The column name(s) to expand if present. 
#' If multiple columns are specified here, they should be separated by 
#' the `sep` and the column name and its value should be separated by the 
#' provided `delim`.
#' 
#' @returns 
#' A metadata table where the `targetCol` is updated to a long form (if it
#' is multi-valued attribute) or spread into multiple columns (if it is 
#' composite attribute).
#' 
#' @examples
#' data(mini_cmd2) # multi-valued attribute
#' data(mini_cmd3) # composite attribute
#' spreadMeta(mini_cmd2, "target_condition")
#' spreadMeta(mini_cmd3, "probing_pocket_depth")
#' 
#' data(mini_cbio)
#' trt_cols <- grep("^treatment_", colnames(mini_cbio), value = TRUE)
#' spreadMeta(mini_cbio, targetCol = trt_cols)
#' 
#' @export
spreadMeta <- function(meta, targetCol) {
    
    ## Validate input
    if (is.null(targetCol)) {
        stop("Provide the name of columns to be spread.")
    }
    if (!is.data.frame(meta)) {
        stop("`meta` input should be a data frame.")
    }
    if (!is.character(targetCol)) {
        stop("`targetCol` input is missing.")
    } else if (!any(targetCol %in% colnames(meta))) {
        stop("The target column doesn't exist in the metadata table.")
    }
    
    ## Extract the delimiter and separater
    delim <- .getDelimiter(meta, targetCol)
    sep <- .getSeparater(meta, targetCol)
    
    if (is.na(sep)) { # multi-valued attribute
        ## [Todo] Can have two layers of multi-values (e.g., "NA<;>NA<;>Bile Duct;Resection<;>Anastomosis")
        targetCol <- .getAssociatedAttr(meta, targetCol) # Include associated attributes (e.g., `_ontology_term_id` or `_unit`) if exist
        res <- getLongMetaTb(meta, targetCol, delim = delim)
    } else { # composite attribute
        ## [Todo] Handling associated attributes (e.g., `_ontology_term_id`) for composite attribute <<<<<<<<<
        res <- getWideMetaTb(meta, targetCol, sep = sep, delim = delim)
    }
    
    return(res)
}

data(mini_cbio)
trt_cols <- grep("^treatment_", colnames(mini_cbio), value = TRUE)
res1 <- spreadMeta(mini_cbio, targetCol = trt_cols)

data(mini_cmd2) # multi-valued attribute
data(mini_cmd3) # composite attribute
res2 <- spreadMeta(mini_cmd2, "target_condition")
# res3 <- spreadMeta(mini_cmd3, "probing_pocket_depth")
res3 <- getWideMetaTb(mini_cmd3, "probing_pocket_depth")

test_that("Test spreadMeta function", {
    expect_equal(dim(res1), c(12,9))
    expect_equal(dim(res2), c(465,7))
    expect_equal(dim(res3), c(10,12)) # `spreadMeta` should be updated to use `getWideMetaTb` for this attribute
    
    expect_equal(res1$treatment_name[9:12], 
                 c("Mitotane", "Mitotane", NA, "Mitotane"))
    expect_equal(res1$treatment_name_ontology_term_id[9:12], 
                 c("NCIT:C664", "NCIT:C664", NA, "NCIT:C664"))
    expect_equal(res1$treatment_type[9:12], 
                 c("Pharmacotherapy", "Pharmacotherapy", "Radiation Therapy", "Pharmacotherapy"))
    expect_equal(res1$treatment_type_ontology_term_id[9:12], 
                 c("NCIT:C15986", "NCIT:C15986", "NCIT:C15313", "NCIT:C15986"))
})

##### getLongMetaTb and getShortMetaTb -----------
data(mini_cmd)

short_tb <- data.frame(
    ind = c("A", "B", "C", "D", "E"),
    aval = c("cat;dog", "chicken", "horse", "frog;pig", "snake"),
    cval = c(1, NA, 3, 4, 5),
    bval = c("red;blue", "yellow", "NA", "green;NA", "brown"))

long_tb <- data.frame(
    ind = c("A", "A", "B", "C", "D", "D", "E"),
    aval = c("cat", "dog", "chicken", "horse", "frog", "pig", "snake"),
    cval = c(1, 1, NA, 3, 4, 4, 5),
    bval = c("red", "blue", "yellow", NA, "green", NA, "brown"))

lmeta <- getLongMetaTb(mini_cmd, "hla")
smeta <- getShortMetaTb(lmeta, targetCol = "hla")
                              

test_that("Test getLongMetaTb function", {
    expect_equal(dim(mini_cmd), c(200,3))
    expect_equal(dim(lmeta), c(539,3))
    ltb <- getLongMetaTb(short_tb, c("aval", "bval"), delim = ";")
    expect_equal(dim(ltb), c(7, 4))
})

test_that("Test getShortMetaTb function", {
    expect_equal(dim(smeta), c(200,3))
    stb <- getShortMetaTb(long_tb, 
                          idCols = "ind", 
                          targetCol = c("aval", "bval"))
    expect_equal(dim(stb), c(5, 4))
})



##### getNarrowMetaTb and getWideMetaTb ---------
wide_tb <- data.frame(
    fruit = c("apple", "banana", "pear", "watermelon", "grape"), 
    shape = c("round", "long", NA, "round", NA),
    color = c("red", "yellow", NA, "green", "purple"),
    size = c("medium", "medium", NA, "large", "small"))

ntb <- getNarrowMetaTb(wide_tb, newCol = "feature", 
                       targetCol = c("color", "shape", "size"), 
                       sep = ":", delim = ";")

test_that("Test getNarrowMetaTb function", {
    expect_equal(dim(ntb), c(5,2))
    expect_true(is.na(ntb[3,2]))
})  
              
## Narrow-table example
narrow_tb <- data.frame(fruit = c("apple", "banana", "pear", "watermelon", 
                                  "grape"), 
                        feature = c("color:red;shape:round;size:medium", 
                                    "color:yellow;shape:long;size:medium",
                                    "color:brown;shape:NA;size:NA",
                                    "color:green;shape:round;size:large",
                                    "color:purple;shape:NA;size:small"))
ntb1 <- getWideMetaTb(narrow_tb, targetCol = "feature", sep = ":", delim = ";")

## Narrow-table example with missing columns
narrow_tb2 <- data.frame(fruit = c("apple", "banana", "pear", 
                                   "watermelon", "grape"), 
                        feature = c("color:red;shape:round;size:medium", 
                                    "color:yellow;shape:long;size:medium",
                                    NA,
                                    "color:green;size:large",
                                    "color:purple;shape:NA;size:small"))
ntb2 <- getWideMetaTb(narrow_tb2, targetCol = "feature", sep = ":", delim = ";")


test_that("Test getWideMetaTb function", {
    expect_equal(dim(ntb1), c(5,4))
    expect_true(is.na(ntb1[3,3]))
    expect_equal(rowSums(is.na(ntb1)), c(0,0,2,0,1))
    expect_equal(as.numeric(colSums(is.na(ntb1))), c(0,0,2,1))
    
    expect_equal(dim(ntb2), c(5,4))
    expect_equal(rowSums(is.na(ntb2)), c(0,0,3,1,1))
    expect_equal(as.numeric(colSums(is.na(ntb2))), c(0,1,3,1))
})

## Subset of cMD metadata for test
library(dplyr)

extDir <- "~/OmicsMLRepo/OmicsMLRepoData/inst/extdata"
cmd <- read.csv(file.path(extDir, "cMD_curated_metadata_release.csv"))

mini_cmd <- cmd %>%
    filter(!is.na(hla)) %>%
    .[1:200,] %>%
    select(curation_id, hla, package)

save(mini_cmd, file = "~/OmicsMLRepo/OmicsMLRepoR/data/mini_cmd.RData")

## Subset of cBioPortalData metadata for test
library(dplyr)

extDir <- "~/OmicsMLRepo/OmicsMLRepoData/inst/extdata"
cbio <- read.csv(file.path(extDir, "cBioPortal_curated_metadata_release_v2.csv"))

other_cols <- c("curation_id", "acronym", "acronym_ontology_term_id", "sex","package")
trt_cols <- grep("^treatment_", colnames(cbio), value = TRUE)
non_na_rows <- which(!is.na(cbio$treatment_name))

mini_cbio <- cbio[non_na_rows[1:10], c(other_cols, trt_cols)]

save(mini_cbio, file = "~/OmicsMLRepo/OmicsMLRepoR/data/mini_cbio.RData")

s2p_get_cache <- function() {
    cache <- tools::R_user_dir("OmicsMLRepo", "cache") # create a directory for cached data
    BiocFileCache::BiocFileCache(cache = cache) # directory path of cache 
}

#' @import BiocFileCache
#' 
s2p_cached_url <- function(url, 
                           rname = url, 
                           ask_on_update = FALSE,
                           ...) {
    bfc <- s2p_get_cache()
    bfcres <- BiocFileCache::bfcquery(x = bfc, 
                                      query = rname, # regular expression pattern(s) to match
                                      field = "rname") # column names in resource to query
    
    rid <- bfcres$rid # auto-generated resource id
    
    ## Cached file not found
    if (!length(rid)) {
        rid <- names(BiocFileCache::bfcadd(x = bfc, rname = rname, fpath = url))
    }
    
    ## If needs update, do the download
    ## bfcneedsupdate() can return NA or a logical vector; make the decision robust
    needs <- BiocFileCache::bfcneedsupdate(bfc, rids = rid)
    
    if (length(needs) > 1) {
        # If all are NA, treat as needing update so we attempt to download.
        if (all(is.na(needs))) {
            needs <- TRUE
        } else {
            # If any element is TRUE (ignoring NA), update.
            needs <- any(needs, na.rm = TRUE)
        }
    } else {
        # Single value: if NA, set to TRUE to attempt download; otherwise use the logical value
        if (is.na(needs)) needs <- TRUE
    }
    
    if (isTRUE(needs)) {
        BiocFileCache::bfcdownload(bfc, rid = rid, ask = ask_on_update)
        message("Updating")
    }
    
    res <- BiocFileCache::bfcrpath(bfc, rids = rid)
    return(res)
}




#' Download a harmonized metadata table
#' 
#' @importFrom readr read_csv
#'
#' @param database Name of the database to get the metadata from. Currently, 
#' there are two available options.
#' \itemize{
#'     \item \code{cMD} : metadata for curatedMetagenomicData
#'     \item \code{cBioPortal} : metadata for cBioPortalData
#' }
#' @param load Default is \code{TRUE}. If it's set to \code{FALSE}, the 
#' metadata table is downloaded to cache but not loaded into memory.
#'
#' @return Curated metadata table or file cache location, if `load = FALSE`.
#'
#' @examples
#' cmd <- getMetadata("cMD")
#'
#' @export
getMetadata <- function(database = NULL, 
                        load = TRUE) {
    if (is.null(database)) {stop("Provide the database name.")}
    # bucket_name <- "omics_ml_repo"
    # request_meta <- paste0(database, "_curated_metadata_release.csv")
    # fpath <- file.path("https://storage.googleapis.com",
    #                    bucket_name, request_meta)
    
    zenodo_url <- "https://zenodo.org/records/16458151/files"
    request_meta <- paste0(database, "_curated_metadata_release.csv")
    fpath <- file.path(zenodo_url, request_meta)
    
    fpath <- s2p_cached_url(fpath)
    if (isTRUE(load)) {
        model <- readr::read_csv(fpath)
        attributes(model)$database <- database
        return(model)
    } else {return(fpath)}
}

library(dplyr)
library(OmicsMLRepoR)

cmd <- getMetadata("cMD")
cbio <- getMetadata("cBioPortal")

test_that("Check getMetadata function", {
    ## Check the correct 'released-version' format
    expect_equal(colnames(cmd)[ncol(cmd)], "last_updated")
    expect_equal(unique(cmd$package), "cMD")
    expect_equal(colnames(cbio)[ncol(cbio)], "last_updated")
    expect_equal(unique(cbio$package), "cBioPortal")
})

test_that("tree_filter: case-insensitive", {
    res1 <- cmd %>% tree_filter(disease, "Colorectal Carcinoma")
    res2 <- cmd %>% tree_filter(disease, "colorectal carcinoma")
    expect_equal(nrow(res1), nrow(res2))
})

# test_that("tree_filter: synonym searching", {
#     syn_res1 <- cmd %>% tree_filter(disease, "CRC")
#     syn_res2 <- cmd %>% tree_filter(disease, "Colorectal Cancer")
#     syn_res3 <- cmd %>% tree_filter(disease, "Colorectal Carcinoma")
#     
#     expect_equal(nrow(syn_res1), nrow(syn_res2))
#     expect_equal(nrow(syn_res1), nrow(syn_res3))
# })

test_that("tree_filter: descendt searching", {
    ds_res <- cmd %>% 
        tree_filter(disease, "Intestinal Disorder") %>%
        select(disease)
    res_terms <- strsplit(ds_res$disease, ";") %>% unlist %>% unique
    ds_terms <- c("Crohn Disease",
                  "Colorectal Carcinoma", 
                  "Inflammatory Bowel Disease",
                  "Irritable Bowel Syndrome")
    expect_true(all(ds_terms %in% res_terms))
})

test_that("tree_filter: logical argument", {
    res_m <- cmd %>% tree_filter(disease, "migraine")
    res_d <- cmd %>% tree_filter(disease, "diabetes")
    res_or <- cmd %>% tree_filter(disease, c("migraine", "diabetes"), "OR")
    res_and <- cmd %>% tree_filter(disease, c("migraine", "diabetes"), "AND")
    res_not <- cmd %>% tree_filter(disease, c("migraine", "diabetes"), "NOT")
    
    expect_equal(nrow(res_m) + nrow(res_d) - nrow(res_and), nrow(res_or))
    expect_equal(nrow(res_or) + nrow(res_not), nrow(cmd))
})

#' Compresses expanded metadata columns to one row per sample
#' 
#' @importFrom dplyr reframe across ungroup group_by_at
#' 
#' @param meta A data frame with expanded treatment columns.
#' @param idCols Optional. A character vector of columns that identify 
#' single samples, such as 'curation_id' and 'sampleId'. Defaults to 
#' standard ID columns.
#' @param targetCol Optional. A character vector of columns to compress if 
#' present. Default is names of all cBioPortal treatment-related columns.
#' @param delim Optional. A delimiter string. Default is `<;>`.
#'
#' @return A data frame where each sample gets a single row
#' 
#' @examples
#' data(mini_cmd)
#' lmeta <- getLongMetaTb(mini_cmd, "hla")
#' res <- getShortMetaTb(lmeta, targetCol = "hla")
#' dim(res) # 200 x 3 table
#' 
#' long_tb <- data.frame(ind = c("A", "A", "B", "C", "D", "D", "E"),
#'                       aval = c("cat", "dog", "chicken", "horse", 
#'                                "frog", "pig", "snake"),
#'                       cval = c(1, 1, NA, 3, 4, 4, 5),
#'                       bval = c("red", "blue", "yellow", NA, "green", 
#'                                NA, "brown"))
#' getShortMetaTb(long_tb, idCols = "ind", targetCol = c("aval", "bval"))
#' 
#' @export
getShortMetaTb <- function(meta, 
                           idCols = NULL, 
                           targetCol = NULL, 
                           delim = "<;>") {
    
    dir <- system.file("extdata", package = "OmicsMLRepoR")
    if (is.null(idCols)) {
        ## Character vector of ID columns
        idCols <- readLines(file.path(dir, "id_columns.txt")) 
    }
    
    if (is.null(targetCol)) {
        ## Character vector of treatment-related columns 
        ## (current but not complete) 
        targetCol <- readLines(file.path(dir, "treatment_columns.txt"))
    }
    
    ## Validate input
    stopifnot(is.data.frame(meta),
              is.character(idCols),
              is.character(targetCol),
              is.character(delim))
    
    ## Print message to user
    message("Compressing data frame: this may take a few minutes\n")
    
    ## Get original column order
    col_order <- colnames(meta)
    
    ## Include associated attributes (e.g., `_ontology_term_id` or `_unit`) if exist
    targetCol <- .getAssociatedAttr(meta, targetCol)
    
    ## Define which columns to group by and leave un-compressed
    gcols <- idCols[which(idCols %in% col_order)]
    ocols <- setdiff(setdiff(col_order, targetCol), idCols) # keep original form
    
    ## Convert `NA` values to character
    meta[is.na(meta)] <- "NA"
    
    ## Compress data frame
    cmeta <- meta %>%
        group_by_at(gcols) %>%
        reframe(
            across(any_of(targetCol), ~paste(na.omit(.), collapse = delim)),
            across(any_of(ocols), ~unique(.))
        ) %>%
        ungroup() %>%
        select(all_of(col_order))
    
    ## Return as data frame
    res <- tibble::as_tibble(cmeta)
    
    ## Convert "NA" to `NA`
    res_all <- .charToLogicNA(res)
    
    return(res)
}


#' Collapse values from multiple columns into one
#' 
#' @import tidyr
#' 
#' @param meta A data frame.
#' @param newCol A character (1). Name of the new column to store collapsed
#' values.
#' @param targetCol A character vector. Names of the columns to be collapsed
#' into one column.
#' @param sep A character (1). Delimiter used to concatenate column name 
#' and its value. Default is double colons, `:`.
#' @param delim A character(1). Separator to use between values/columns. 
#' Default is `;`.
#' @param remove With the default, `TRUE`, this function will remove input 
#' columns from output data frame.
#' @param na.rm With the default, `TRUE`, missing values will be removed 
#' prior to uniting each value. 
#' @param sort With the default, `TRUE`, the united columns will be ordered
#' alphabetically.
#'
#' @return A data frame where target columns (\code{targetCol}) are collapsed
#' into a single column. The original column name and its value are 
#' concatenated with the `sep` input and the column:value pairs are separated
#' by the `delim` input. Target columns will be merged in the alphabetical 
#' order of their names.
#' 
#' @examples
#' wide_tb <- data.frame(fruit = c("apple", "banana", "pear", "watermelon", 
#'                                 "grape"), 
#'                       shape = c("round", "long", NA, "round", NA),
#'                       color = c("red", "yellow", NA, "green", "purple"),
#'                       size = c("medium", "medium", NA, "large", "small"))
#' getNarrowMetaTb(wide_tb, 
#'                 newCol = "feature", 
#'                 targetCol = c("color", "shape", "size"), 
#'                 sep = ":", delim = ";")
#' 
#' @export
getNarrowMetaTb <- function(meta, 
                            newCol = NULL,
                            targetCol = NULL,
                            sep = ":",
                            delim = ";",
                            remove = TRUE,
                            na.rm = TRUE,
                            sort = TRUE) {
    
    if (is.null(targetCol)) {
        msg <- "Provide the name of columns to combine."
        stop(msg)
    }
    
    if (is.null(newCol)) {
        msg <- "Provide the name of column to store collpased values."
        stop(msg)
    }
    
    target_exist <- targetCol %in% colnames(meta)
    if (sum(target_exist) == 0) {
        msg <- "None of the requested target column(s) exist in the metadata table."
        stop(msg)
    }
    
    cols <- targetCol[target_exist]
    modifiedMeta <- meta
    
    for (col in cols) {
        colregex <- paste0("^", col, "$")
        col_ind <- grep(colregex, colnames(modifiedMeta))
        modifiedMeta[[col_ind]] <- paste(col,
                                         as.character(modifiedMeta[[col_ind]]),
                                         sep = sep)
    }
    
    ## Help `na.rm = TRUE` formatting: updated characterized NA back to logical NA
    na_str <- paste0(".*", sep, "NA")
    if (isTRUE(na.rm)) {
        modifiedMeta <- apply(modifiedMeta, 2, 
                              function(x) gsub(na_str, NA, x)) %>% 
            as.data.frame
    }
    
    ## Unite target columns
    if (isTRUE(sort)) {targetCol <- sort(targetCol)} # alphabetical order of the columns
    united <- unite(modifiedMeta, 
                    col = {{newCol}}, # embracing operator to inject
                    targetCol, 
                    sep = delim,
                    remove = remove,
                    na.rm = na.rm)
    
    ## Help `na.rm = TRUE` formatting: update returned empty string to NA
    if (isTRUE(na.rm)) {
        united[united == ""] <- NA
    }
    
    ## Return as a tibble
    res <- tibble::as_tibble(united)
    
    ## Convert "NA" to `NA`
    res_all <- .charToLogicNA(res)
    return(res)
}

## Create a collection of all the ancestors of ontology terms used in the
## curated/harmonized metadata

# Retrieves all ancestors for supplied terms
# 
# @import rols
# 
# @param onto A character vector. Name(s) of ontologies that terms are from.
# @param terms A character vector of ontology term IDs.
# 
# @return A named list. Names of elements are original nodes (`terms`). 
# Each element is a character vectors containing the ancestors of the 
# element name (i.e., original terms provided).
# 
# @examples
# terms <- c("NCIT:C25301", "NCIT:C29844", "NCIT:C29846", "NCIT:C29848")
# getNodes(onto = "NCIT", terms = terms)
# 
getNodes <- function(onto, terms) {
    # Load ontology
    ontob <- Ontology(onto)
    
    # Get unique terms
    terms <- unique(terms)
    
    # Initialize list to store retrieve nodes
    all_nodes <- list()
    
    # Loop through supplied terms
    for (i in seq_along(terms)) {
        print(paste0("Getting possible nodes for ", terms[i]))
        
        tryCatch({
            # Get term information and ancestors from ontology
            cur_trm <- Term(ontob, terms[i])
            ancs <- ancestors(cur_trm)
            
            # Filter out ancestors labeled as ontology root
            not_root <- Filter(function(x) attr(x, "is_root") == FALSE, ancs@x)
            
            # Save ancestors
            node_names <- names(not_root)
            node_names <- list(node_names[node_names != "NULL"])
            
        }, error = function(e) {
            print(e)
            print("Original term assigned as node, proceeding to next term")
            node_names <<- terms[i]
        })
        
        # Save ancestors under original term
        all_nodes <- c(all_nodes, node_names)
        names(all_nodes)[i] <- terms[i]
    }
    
    return(all_nodes)
}


#' Retrieve and save ancestors of a given ontology term
#'
#' @param ids A character vector of ontology term ids
#' @param dbs A character vector of corresponding ontologies, with the same
#' length of `ids`. Single string is also accepted if all terms are from a 
#' single ontology.
#' 
#' @return A named list of character vectors containing the ancestors of 
#' the original term. Name of each element is the original term the ancestors
#' are traced from.
#' 
#' @examples
#' ids <- c("EFO:0005856", "NCIT:C122177", "HP:0001541", 
#'          "NCIT:C28397", "EFO:0003914", "EFO:0003780")
#' dbs <- c("EFO", "NCIT", "HP", "NCIT", "EFO", "EFO")
#' getAncestors(ids, dbs)
#' 
getAncestors <- function(ids, dbs) {
    
    map <- data.frame(id = ids, db = dbs)
    tryCatch({
        onto_frames <- split(map, map$db)
        onto_terms <- lapply(onto_frames, function(x) x$id)
        onto_nodes <- mapply(function(n, t) getNodes(n, t), 
                             names(onto_terms), 
                             onto_terms, 
                             SIMPLIFY = FALSE)
        onames <- unlist(lapply(onto_nodes, function(x) names(x)), 
                         use.names = FALSE)
        oancs <- unlist(onto_nodes, recursive = FALSE, use.names = FALSE)
        names(oancs) <- onames
        return(oancs)
    }, error = function(e) {
        print(e)
    })
}

#' Wrapper to save ancestor info for all curated features within a metadata 
#' database. Currently, we have established curated features for 
#' curatedMetagenomicData (cMD) and cBioPortalData.
#' 
#' @importFrom dplyr select all_of bind_rows distinct
#' @importFrom tidyr separate_longer_delim 
#' 
#' @param curatedMetaTb A curated metadata table. Curated ontology terms should
#' be under the column name satisfying the pattern, `^.*_ontology_term_id$`
#' @param saveAs A character (1). The file path for the returned list.
#' 
saveAncestors <- function(curatedMetaTb, saveAs) {
    
    ## Extract ontology terms incorporated into the curated metadata
    idColInds <- grep("_ontology_term_id", colnames(curatedMetaTb))
    idCols <- colnames(curatedMetaTb)[idColInds]
    
    ## All the unique ontology terms used for curated attributes
    ## A named list, where the name of the element is the target attribute
    allIds <- apply(curatedMetaTb[idCols], 2, 
                    function(x) strsplit(x, split = ";") %>%
                        unlist %>% na.omit %>% unique)
    names(allIds) <- gsub("curated_|_ontology_term_id", "", names(allIds))
    
    ## Create a `tb` with three columns:
    ## `attributes` (curated column name), `ontology_term_id`, and `ontology_term_db`
    tb <- stack(allIds)
    colnames(tb) <- c("ontology_term_id", "attributes")
    tb$ontology_term_db <- get_ontologies(tb$ontology_term_id)
    
    ## Get all the ancestors for each ontology term
    allAncestors <- getAncestors(tb[,"ontology_term_id"],
                                 tb[,"ontology_term_db"])
    
    ## Collapse all the ancestor terms
    compact <- lapply(allAncestors, function(x) paste(x, collapse = ";"))
    ancestorTb <- stack(compact)
    colnames(ancestorTb) <- c("ancestors", "ontology_term_id")
    
    ## Final table with three columns:
    ## `attributes` (curated column name), `ontology_term_id`, and `ancestors`
    res <- dplyr::full_join(tb[c("attributes", "ontology_term_id")], 
                            ancestorTb, 
                            by = "ontology_term_id")
    
    write.csv(res, saveAs, row.names = FALSE)
}

#' Extract all the terms used in a quired attribute/column
#'
#' @importFrom rlang is_empty
#' @importFrom utils read.csv
#' 
#' @param attribute A character (1). Name of the attribute/column you want to 
#' extract the terms used under. 
#' @param db A character(1). Currently, `cMD` (curatedMetagenomicData) is only
#' supported.
#' 
#' @return A data frame with two columns - existing values under the quried
#' attribute (`allowedvalues` column) and their ontology term id (`ontology`
#' column).
#' 
#' @examples
#' availableTerms("age_group")
#' availableTerms("disease")
#'
#' @export
availableTerms <- function(attribute, db = "cMD") {

    ## Curated cMD metadata data dictionary
    dir <- system.file("extdata", package = "OmicsMLRepoR")
    fname <- paste0(db, "_data_dictionary.csv") 
    dd <- utils::read.csv(file.path(dir, fname), header = TRUE)

    ## Separate the attribute to check
    ind <- which(dd$ColName == attribute)
    
    ## Sanity check: the presence of attribute in the metadata
    if (is_empty(ind)) {stop("Quried attribute doesn't exist in the metadata.")}

    ## Extract allowed values
    allowedvalues <- strsplit(dd$AllowedValues[ind], "\\;") %>% unlist
    # ontology <- strsplit(dd$Ontology[ind], "\\|") %>% unlist
    ontology <- strsplit(dd$DynamicEnum[ind], ";") %>% unlist %>% get_ontologies(., ":")
    res_tb <- data.frame(allowedvalues = allowedvalues,
                         ontology = ontology)

    return(res_tb)
}

#' @name sample_metadata 
#' @title sample_metadata
#' @description A small data table to demonstrating the data reshaping 
#' functions in OmicsMLRepoR.
#' @keywords data
#' @format A data frame with 4 rows and 7 columns
#' @author Sehyun Oh \email{shbrief@gmail.com} 
"sample_metadata"


#' @name mini_cmd 
#' @title A subset of cMD metadata
#' @description A subset of curated version of `sampleMetadata` from the 
#' curatedMetagenomicData (cMD, ver.3.8.0) package.
#' @keywords data
#' @format A data frame with 200 samples and 3 columns ('curation_id',
#' 'hla', and 'package')
#' @author Sehyun Oh \email{shbrief@gmail.com}
"mini_cmd"


#' @name mini_cmd2
#' @title A subset of cMD metadata
#' @description A subset of curated version of `sampleMetadata` from the 
#' curatedMetagenomicData (cMD, ver.3.8.0) package.
#' @keywords data
#' @format A data frame with 200 samples and 7 columns ('curation_id', 
#' 'target_condition', 'target_condition_ontology_term_id',
#' 'pmid', 'disease', 'disease_ontology_term_id', 'package'). 
#' The two key exemplary attributes ('target_condition' and 'disease') 
#' selected here contain multiple values. 
#' @author Sehyun Oh \email{shbrief@gmail.com}
"mini_cmd2"


#' @name mini_cmd3
#' @title A subset of cMD metadata
#' @description A subset of curated version of `sampleMetadata` from the 
#' curatedMetagenomicData (cMD, ver.3.8.0) package.
#' @keywords data
#' @format A data frame with 200 samples and 7 columns ('curation_id', 
#' 'pmid', 'package', 'target_condition', 'feces_phenotype', 
#' 'probing_pocket_depth', 'target_condition_ontology_term_id',
#' 'feces_phenotype_ontology_term_id', 'probing_pocket_depth_ontology_term_id'). 
#' The 'target_condition' is multi-valued attribute, and 'feces_phenotype' and
#' 'probing_pocket_depth' are composite attributes.
#' @author Sehyun Oh \email{shbrief@gmail.com}
"mini_cmd3"

#' @name mini_cbio
#' @title A subset of cBioPortalData metadata
#' @description A subset of curated version of cBioPortal's clinical metadata.
#' @keywords data
#' @format A data frame with 10 samples and 9 columns ('curation_id',
#' 'acronym', 'acronym_ontology_term_id', 'sex', 'package', 'treatment_name',
#' 'treatment_name_ontology_term_id', 'treatment_type', 
#' 'treatment_type_ontology_term_id')
#' @author Sehyun Oh \email{shbrief@gmail.com}
"mini_cbio"

# Collect both labels and obo_ids related to the query term
# 
# This function can take multiple obo_id and labels, and return both 
# labels/obo_ids exactly matching with the `query`. It subsets the output from
# `getOntoInfo` function only to the `label` and/or `obo_id`.
# 
# @param query A character vector of terms or term ids. For example, 
# `c("NCIT:C35025", "HP:0003003", "colon cancer")`.
# @param ontology A character vector defining the ontology to be queried. 
# Default is the empty character, to search all ontologies.
# @param returns A character vector of returned value's format. Available
# options are `c("label", "obo_id)` (default).
# 
# @return A character vector of all the related terms' label and obo_id.
# 
.getAllTargetForms <- function(query, 
                               ontology = "",
                               returns = c("label", "obo_id")) {
    
    resAll <- lapply(query, getOntoInfo, ontology) %>%
        bind_rows(.id = colnames(.))
    
    if (returns == "label") {
        res <- unique(c(resAll$label))
    } else if (returns == "obo_id") {
        res <- unique(c(resAll$obo_id))
    } else if (all(returns %in% c("label", "obo_id"))) {
        res <- unique(c(resAll$label, resAll$obo_id))
    }
    
    return(res)
}


# Find distant relatives
# 
# This function takes a list of ontology terms and their ancestors, where
# the lowest descent serves as a name of the element, as a `pool`. Names 
# of all the elements that have the `target` term in their ancestor list 
# (i.e., sharing the ancestors) are returned. 
# 
# This functionality is the base of searching metadata leveraging ontology, 
# because a specific term can be used to query all the related, decendant
# terms used in the metadata.
# 
# @param pool A named list of the ancestors for a given ontology term. The 
# given ontology term is also included in the list and serves as a name of
# the element.
# @param target A character vector of ontology ids.
#'
# @return A character vector of ontology term ids having any of `target` 
# terms as their ancestor.
#'
# @examples
# ancestors <- list(
#     "NCIT:C5490"=c("NCIT:C5490","NCIT:C4910","NCIT:C2955","NCIT:C4978"),
#     "NCIT:C177680"=c("NCIT:C177680","NCIT:C4910","NCIT:C2955","NCIT:C4978"),
#     "NCIT:C2955"=c("NCIT:C2955","NCIT:C4978","NCIT:C3141"))
# targets <- "NCIT:C4910"
# .findDistantRelatives(pool = ancestors, target = targets)
# 
.findDistantRelatives <- function(pool, target) {
    match <- lapply(pool, 
                    function(x) length(intersect(x, target)) != 0) %>% unlist
    res <- names(pool)[which(match)] %>% unique
    return(res)
}


# Keep rows that include the queried terms and identical/similar to them 
# 
# Similar to \code{\link[dplyr]{filter}} function, while its filtering 
# includes ontology terms and ids identical or similar to the query term 
# across different ontologies collected through OLS search.
# 
# @importFrom rlang enquo
# @importFrom dplyr filter
# 
# @param .data A data frame
# @param col A character (1). Column name to filter by.
# @param query A character vector containing words or ids to be used in the
# ontology search
# @param delim A character (1) used to separate multiple values. 
# 
# @return Data frame filtered by provided queries along with their ontology
# synonyms/ids in the specified column. Not case-sensitive.
# 
# @examples
# data(sample_metadata)
# onto_filter(df, curated_disease, c("diabetes", "adenoma"))
# 
onto_filter <- function(.data, col, query, delim = NULL) {
    
    ## Search OLS
    targets <- tolower(c(query, .getAllTargetForms(query)))
    
    ## Filter data
    .data %>%
        rowwise() %>%
        dplyr::filter(any(tolower(unlist(strsplit(!!enquo(col), split = delim)))
                          %in% targets))
}


#' Keep rows that include the queried terms and their descendants  
#' 
#' Similar to \code{\link[dplyr]{filter}} function, while its filtering 
#' includes descendants and synonyms of the query term in addition to ontology 
#' terms and ids identical or similar to the query term across different 
#' ontologies collected through OLS search. 
#' 
#' @importFrom rlang enquo as_name sym
#' 
#' @param .data A data frame
#' @param col A character (1). Column name to filter by.
#' @param query A character vector containing words or ids to be used in the
#' ontology search
#' @param logic A character (1). Operator used to determine filtering method.
#' Values allowed: "AND", "OR", "NOT". Defaults to "OR"
#' @param delim A character (1) used to separate multiple values. If your
#' `.data` input is obtained from \code{getMetadata} function, this input is
#' automatically configured.
#' 
#' @return Data frame filtered by provided queries along with child terms in the
#' specified column
#' 
#' @examples
#' meta <- getMetadata("cMD")
#' tree_filter(meta, disease, c("pancreatic disease", "cancer"))
#' 
#' @export
tree_filter <- function(.data, col, query, logic = "OR", delim = NULL) {
    
    ## Check that curated feature is present
    feat_name <- as_name(enquo(col))
    id_col <- paste0(feat_name, "_ontology_term_id")
    
    if (!feat_name %in% colnames(.data)) {
        msg <- "The selected column does not exist in the metadata table"
        stop(msg)
    } else if (!id_col %in% colnames(.data)) {
        msg <- "The selected column was not curated with ontology terms"
        stop(msg)
    }
    
    ## Check that logic operator is valid
    if (!logic %in% c("AND", "OR", "NOT")) {
        msg <- paste0("\"", logic, "\" is not a valid value of \"logic\". Please enter \"AND\", \"OR\", or \"NOT\"")
        stop(msg)
    }
    
    ## Get delimiter
    targetDB <- .getTargetDB(.data)
    delim <- .getDelimiter(.data, feat_name, delim) 
    ontoDBs <- .getOntos(.data, feat_name)
    
    ## Search OLS
    targets <- lapply(query, function(x) unique(.getAllTargetForms(x,
                                                                   ontoDBs,
                                                                   "obo_id")))
    
    ## Load ancestors for the appropriate database
    dir <- system.file("extdata", package = "OmicsMLRepoR")
    fname <- paste0(targetDB, "_ancestors.csv")
    allAncestors <- read.csv(file.path(dir, fname), header = TRUE)
    
    unlistedAncestors <- lapply(allAncestors$ancestors, 
                                function(x) unlist(strsplit(x, split = ";")))
    names(unlistedAncestors) <- allAncestors$ontology_term_id
    
    ## Retrieve ids to filter by
    related_terms <- lapply(targets, function(x)
        .findDistantRelatives(unlistedAncestors, x))
    terms_to_find <- mapply(function(a, b) unique(c(a, b)),
                            related_terms,
                            targets,
                            SIMPLIFY = FALSE)
    
    ## Filter data
    filter_results <- list()
    for (i in seq_along(terms_to_find)) {
        filter_results[[i]] <- .data %>%
            rowwise() %>%
            filter(any(unlist(strsplit(!!sym(id_col), split = delim)) %in%
                           terms_to_find[[i]]))
    }
    
    ## Combine filtered data based on logic
    if (logic == "AND") {
        results <- Reduce(intersect, filter_results)
    } else if (logic == "NOT") {
        results <- setdiff(.data, unique(bind_rows(filter_results)))
    } else  if (logic == "OR") {
        results <- unique(bind_rows(filter_results))
    }
    return(results)
}

## Subset of cMD metadata for test
library(dplyr)
library(OmicsMLRepoR)

extDir <- "~/OmicsMLRepo/OmicsMLRepoData/inst/extdata"
cmd <- read.csv(file.path(extDir, "cMD_curated_metadata_release.csv"))

cols <- c("curation_id", "pmid", "package", "target_condition", 
          "feces_phenotype", "probing_pocket_depth")
cols <- .getAssociatedAttr(cmd, cols)
rows <- c(grep(";", cmd$feces_phenotype)[1:5], 
          grep(";", cmd$probing_pocket_depth)[1:5])

mini_cmd3 <- cmd[rows, cols] 

save(mini_cmd3, file = "~/OmicsMLRepo/OmicsMLRepoR/data/mini_cmd3.RData")

## Subset of cMD metadata for test
library(dplyr)

extDir <- "~/OmicsMLRepo/OmicsMLRepoData/inst/extdata"
cmd <- read.csv(file.path(extDir, "cMD_curated_metadata_release.csv"))

# Select samples with multiple values for two attributes - `target_condition` and `disease`
complexInd <- intersect(grep(";", cmd$target_condition), grep(";", cmd$disease))

mini_cmd2 <- cmd %>%
    select(curation_id, target_condition, target_condition_ontology_term_id,
           pmid, disease, disease_ontology_term_id, package) %>%
    .[complexInd[1:200],] 

save(mini_cmd2, file = "~/OmicsMLRepo/OmicsMLRepoR/data/mini_cmd2.RData")

#' Plot ontology tree
#' 
#' @import rols
#' @import dplyr
#' @import DiagrammeR 
#' @importFrom plyr mapvalues
#' @importFrom data.tree FromDataFrameNetwork
#' @importFrom jsonlite fromJSON
#' 
#' @param term A character (1). Ontology term id (obo_id)
#' @param display A character (1) specifying a node labeling option. Two 
#' available options are `Term` for ontology term or IRI 
#' (Internationalized Resource Identifier) and `Text` for the label or 
#' preferred name.
#' 
#' @return A ontology tree plot. All the terms used in the output plot are 
#' ancestors of the queried term, so the queried term is the tip.
#' 
#' @examples 
#' ontoTreePlot("NCIT:C2852", "Term")
#' 
#' @export
ontoTreePlot <- function(term, display = c("Term", "Text")) {
    display <- match.arg(display)
    
    sample_id <- term
    sample_db <- get_ontologies(term)
    
    ## load term object and retrieve link to JSON tree
    ontob <- olsOntology(sample_db)
    cur_trm <- olsTerm(ontob, sample_id)
    jstree <- cur_trm@links$jstree$href
    
    ## transform JSON into dataframe
    tree_frame <- jsonlite::fromJSON(jstree)
    
    ## transform dataframe into usable edgelist
    map <- tree_frame %>%
        rowwise() %>%
        mutate(term = unlist(strsplit(iri, split = "/"))[5]) %>%
        select(id, term, text)
    
    edgelist_base <- tree_frame %>%
        select(parent, id) %>%
        rename(from = parent,
               to = id) %>%
        filter(from != "#")
    
    ## display options
    foo <- base::switch(display, Term = map$term, Text = map$text)
    edgelist <- edgelist_base %>%
        mutate(from = plyr::mapvalues(from, map$id, foo, warn_missing = FALSE)) %>%
        mutate(to = plyr::mapvalues(to, map$id, foo, warn_missing = FALSE))
    
    ## plot tree with data.tree package; other packages will also work with the edgelist
    tree <- data.tree::FromDataFrameNetwork(edgelist)
    plot(tree)
}

#' OmicsMLRepoR: A package for browsing harmonized metadata through ontology
#'
#' The OmicsMLRepoR package provides functions to browse the harmonized 
#' metadata created under the OmicsMLRepo project. It supports data 
#' navigation if the metadata incorporates ontology. 
#'
#' @section Key Functions:
#' \itemize{
#'   \item \code{\link{getMetadata}}: Download a harmonized metadata table
#'   \item \code{\link{tree_filter}}: Find samples including the queried 
#'   terms and their descendants
#' }
#'
#' @section Additional Information:
#' For more detailed information, see the vignette:
#' \code{vignette("Quickstart", package = "OmicsMLRepoR")}
#'
#' @name OmicsMLRepoR
NULL

#!/bin/bash

#' To be used after a Bioconductor release
#'
#' Use `git remote -v` to check if you have the correct origin and upstream
#' remotes 
#'
#' If NOT, use
#      `git remote add upstream git@git.bioconductor.org:packages/PACKAGE`
#' If your origin is not GitHub, use
#'     `git remote origin set-url git@github.com:USER/PACKAGE`
#'
#' param RELEASE the release branch name e.g., RELEASE_3_14
#'
#' usage:
#' cd PACKAGE
#' ./update_release.sh RELEASE_3_14
#' ./update_release.sh RELEASE_3_14 devel

RELEASE=$1
DEFAULT=${2:-master}

git fetch --all
git pull upstream $DEFAULT
git push origin $DEFAULT
git checkout -b $RELEASE upstream/$RELEASE
git push origin $RELEASE
git checkout $DEFAULT

---
title: "OmicsMLRepoR - Quickstart"
author: "Sehyun Oh, Kaelyn Long"
date: "`r format(Sys.time(), '%B %d, %Y')`"
vignette: >
  %\VignetteIndexEntry{Quickstart}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
output:
  BiocStyle::html_document:
    number_sections: yes
    toc: yes
    toc_depth: 4
editor_options: 
  markdown: 
    wrap: 72
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(comment = "#>", 
                      collapse = TRUE, 
                      message = FALSE, 
                      warning = FALSE)
```

# Introduction

Our OmicsMLRepo project aims to improve the AI/ML-readiness of Omics datasets 
available through Bioconductor. One of the main activities under this project 
is metadata harmonization (e.g., remove redundant information) and 
standardization (i.e., incorporate ontology).

Currently, we released the harmonized version of metadata for two Bioconductor 
data packages - `r BiocStyle::Biocpkg("curatedMetagenomicData")`containing 
human microbiome data and `r BiocStyle::Biocpkg("cBioPortalData")` package 
on cancer genomics data. OmicsMLRepoR is a software package allowing users 
to easily access the harmonized metadata and to leverage
ontology in metadata search.

OmicsMLRepoR package provides the three major functions:\
1. Download the harmonized metadata\
2. Browse the harmonized metadata using ontology\
3. Manipulate the 'shape' of the harmonized metadata


## Load package
```{r}
suppressPackageStartupMessages({
    library(OmicsMLRepoR)
    library(dplyr)
    library(curatedMetagenomicData)
    library(cBioPortalData)
})
```

## Load the metadata

You can download the harmonized version of metadata using the `getMetadata` 
function. Currently, two options are available - `cMD` and `cBioPortalData`.

```{r}
cmd <- getMetadata("cMD")
cmd
```

```{r}
cbio <- getMetadata("cBioPortal")
cbio
```

# Access metadata
Harmonized metadata can be easily searched by `dplyr` functions. To fully 
leverage ontologies incorporated in harmonized metadata and provide more robust 
data browsing experience, the package provides the `tree_filter` function. 
Note, that `tree_filter` can be used on the attributes mapped to the ontology
terms:

```{r echo=FALSE}
colnames(cmd)[grep("_ontology_term_id", colnames(cmd))] %>% 
    gsub("_ontology_term_id", "", .)
```


## Robust search using ontology
Compared to the typical searching in the original metadata from the 
`curatedMetagenomicData`, OmicsMLRepoR enables more robust data browsing, 
including case-insensitive, synonyms and descendant searching capabilities.

Searching the same information in the original, unharmonized metadata
(`sampleMetadata`) from the `curatedMetagenomicData` package is much less 
robust:

```{r robust_browsing}
## Information spread out in two different columns
nrow(sampleMetadata |> filter(study_condition == "CRC"))
nrow(sampleMetadata |> filter(disease == "CRC"))

## Case sensitive
nrow(sampleMetadata |> filter(study_condition == "CRC"))
nrow(sampleMetadata |> filter(study_condition == "crc"))

## Synonyms not covered
nrow(sampleMetadata |> filter(study_condition == "Colorectal Carcinoma"))
nrow(sampleMetadata |> filter(study_condition == "Colorectal Cancer"))
```

### Not case-sensitive
`tree_filter` is not case-sensitive.
```{r not_case_sensitive}
nrow(cmd |> tree_filter(disease, "Colorectal Carcinoma"))
nrow(cmd |> tree_filter(disease, "colorectal carcinoma"))
```

### Include synonyms
`tree_filter` includes the synonyms of the queried terms in its searching.
```{r include_synonyms}
syn_res1 <- cmd |> tree_filter(disease, "CRC")
syn_res2 <- cmd |> tree_filter(disease, "Colorectal Cancer")
syn_res3 <- cmd |> tree_filter(disease, "Colorectal Carcinoma")

nrow(syn_res1)
nrow(syn_res2)
nrow(syn_res3)
```

Check that the returned results are identical.
```{r sanity_check}
unique(syn_res1$disease)
unique(syn_res2$disease)
unique(syn_res3$disease)
```

### Search descendants in ontology tree
`tree_filter` includes all the descendants of the queried term in its searching.
```{r descendant_search}
onto_res <- cmd |> tree_filter(disease, "Intestinal Disorder")
unique(onto_res$disease)
```

## Multiple searching terms
For example, you can search for any row including a disease related to either 
"migraine" or "diabetes."

```{r multiple_searching_terms}
res_or <- cmd %>% tree_filter(disease, c("migraine", "diabetes"), "OR")
```

We can also change the "OR" argument (default) to either "AND" or "NOT" and 
change the filtering action. "AND" will return any rows including a disease
value that is related to both "migraine" and "diabetes," and "NOT" will return
any rows including a disease value that is not related to either "migraine" or
"diabetes."

```{r different_filter_logic}
res_and <- cmd %>% tree_filter(disease, c("migraine", "diabetes"), "AND")
res_not <- cmd %>% tree_filter(disease, c("migraine", "diabetes"), "NOT")
```

You can combine `tree_filter` and `dplyr` functions. For example, if you want 
all rows with a disease value related to either "migraine" or "diabetes," as 
well as with an age_years value under 30,

```{r example}
res_or_below30 <- cmd %>% 
    filter(age_years < 30) %>%
    tree_filter(disease, c("migraine", "diabetes"))
```


## Collapse/Expand metadata

Some metadata columns (e.g., `biomarker`) contain multiple, similar
attributes separated with a specific delimiter (i.e., `<;>`). Our
harmonization use this structure because they are related information
often looked up together.

```{r}
cmd_biomarker <- cmd %>% 
    filter(!is.na(biomarker)) %>% 
    select(curation_id, biomarker)
wtb <- getWideMetaTb(cmd_biomarker, "biomarker")
head(wtb)
```

```{r}
ltb <- getLongMetaTb(cmd, targetCol = "target_condition")
dim(cmd)
dim(ltb)
```


# Download omics data
## curatedMetagenomicData

```{r debug_needed, echo=FALSE}
cmd_sub <- tree_filter(cmd, target_condition, "Alzheimer's disease")
```

```{r}
cmd_dat <- cmd %>%
    tree_filter(col = "disease", "Type 2 Diabetes Mellitus") %>%
    filter(sex == "Female") %>%
    filter(age_group == "Elderly") %>%
    returnSamples("relative_abundance", rownames = "short")
```

## cBioPortalData
```{r}
cbio_sub <- cbio %>%
    getLongMetaTb("treatment_name", "<;>") %>%
    filter(treatment_name == "Fluorouracil") %>%
    filter(age_at_diagnosis > 50) %>%
    filter(sex == "Female") %>%
    getShortMetaTb(idCols = "curation_id", targetCol = "treatment_name")

dim(cbio_sub)
studies <- unique(cbio_sub$studyId)
studies
```

A simple `for` loop can collect samples from multiple studies. For example,
```{r echo=FALSE, eval=FALSE}
cbio_api <- cBioPortal()
resAll <- as.list(vector(length = length(studies)))

for (i in seq_along(studies)) {
    study <- studies[i]
    samples <- cbio_sub %>%
        filter(studyId == study) %>%
        pull(sampleId)

    res <- cBioPortalData(
        api = cbio_api,
        by = "hugoGeneSymbol",
        studyId = study,
        sampleIds = samples,
        genePanelId = "IMPACT341"
    )
    
    resAll[[i]] <- res
}
```


# Session Info
<details>
```{r}
sessionInfo()
```
</details>

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{mini_cmd2}
\alias{mini_cmd2}
\title{A subset of cMD metadata}
\format{
A data frame with 200 samples and 7 columns ('curation_id', 
'target_condition', 'target_condition_ontology_term_id',
'pmid', 'disease', 'disease_ontology_term_id', 'package'). 
The two key exemplary attributes ('target_condition' and 'disease') 
selected here contain multiple values.
}
\usage{
mini_cmd2
}
\description{
A subset of curated version of `sampleMetadata` from the 
curatedMetagenomicData (cMD, ver.3.8.0) package.
}
\author{
Sehyun Oh \email{shbrief@gmail.com}
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ontoTreePlot.R
\name{ontoTreePlot}
\alias{ontoTreePlot}
\title{Plot ontology tree}
\usage{
ontoTreePlot(term, display = c("Term", "Text"))
}
\arguments{
\item{term}{A character (1). Ontology term id (obo_id)}

\item{display}{A character (1) specifying a node labeling option. Two 
available options are `Term` for ontology term or IRI 
(Internationalized Resource Identifier) and `Text` for the label or 
preferred name.}
}
\value{
A ontology tree plot. All the terms used in the output plot are 
ancestors of the queried term, so the queried term is the tip.
}
\description{
Plot ontology tree
}
\examples{
ontoTreePlot("NCIT:C2852", "Term")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{mini_cmd3}
\alias{mini_cmd3}
\title{A subset of cMD metadata}
\format{
A data frame with 200 samples and 7 columns ('curation_id', 
'pmid', 'package', 'target_condition', 'feces_phenotype', 
'probing_pocket_depth', 'target_condition_ontology_term_id',
'feces_phenotype_ontology_term_id', 'probing_pocket_depth_ontology_term_id'). 
The 'target_condition' is multi-valued attribute, and 'feces_phenotype' and
'probing_pocket_depth' are composite attributes.
}
\usage{
mini_cmd3
}
\description{
A subset of curated version of `sampleMetadata` from the 
curatedMetagenomicData (cMD, ver.3.8.0) package.
}
\author{
Sehyun Oh \email{shbrief@gmail.com}
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gatherMeta.R
\name{getNarrowMetaTb}
\alias{getNarrowMetaTb}
\title{Collapse values from multiple columns into one}
\usage{
getNarrowMetaTb(
  meta,
  newCol = NULL,
  targetCol = NULL,
  sep = ":",
  delim = ";",
  remove = TRUE,
  na.rm = TRUE,
  sort = TRUE
)
}
\arguments{
\item{meta}{A data frame.}

\item{newCol}{A character (1). Name of the new column to store collapsed
values.}

\item{targetCol}{A character vector. Names of the columns to be collapsed
into one column.}

\item{sep}{A character (1). Delimiter used to concatenate column name 
and its value. Default is double colons, `:`.}

\item{delim}{A character(1). Separator to use between values/columns. 
Default is `;`.}

\item{remove}{With the default, `TRUE`, this function will remove input 
columns from output data frame.}

\item{na.rm}{With the default, `TRUE`, missing values will be removed 
prior to uniting each value.}

\item{sort}{With the default, `TRUE`, the united columns will be ordered
alphabetically.}
}
\value{
A data frame where target columns (\code{targetCol}) are collapsed
into a single column. The original column name and its value are 
concatenated with the `sep` input and the column:value pairs are separated
by the `delim` input. Target columns will be merged in the alphabetical 
order of their names.
}
\description{
Collapse values from multiple columns into one
}
\examples{
wide_tb <- data.frame(fruit = c("apple", "banana", "pear", "watermelon", 
                                "grape"), 
                      shape = c("round", "long", NA, "round", NA),
                      color = c("red", "yellow", NA, "green", "purple"),
                      size = c("medium", "medium", NA, "large", "small"))
getNarrowMetaTb(wide_tb, 
                newCol = "feature", 
                targetCol = c("color", "shape", "size"), 
                sep = ":", delim = ";")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree_filter.R
\name{tree_filter}
\alias{tree_filter}
\title{Keep rows that include the queried terms and their descendants}
\usage{
tree_filter(.data, col, query, logic = "OR", delim = NULL)
}
\arguments{
\item{.data}{A data frame}

\item{col}{A character (1). Column name to filter by.}

\item{query}{A character vector containing words or ids to be used in the
ontology search}

\item{logic}{A character (1). Operator used to determine filtering method.
Values allowed: "AND", "OR", "NOT". Defaults to "OR"}

\item{delim}{A character (1) used to separate multiple values. If your
`.data` input is obtained from \code{getMetadata} function, this input is
automatically configured.}
}
\value{
Data frame filtered by provided queries along with child terms in the
specified column
}
\description{
Similar to \code{\link[dplyr]{filter}} function, while its filtering 
includes descendants and synonyms of the query term in addition to ontology 
terms and ids identical or similar to the query term across different 
ontologies collected through OLS search.
}
\examples{
meta <- getMetadata("cMD")
tree_filter(meta, disease, c("pancreatic disease", "cancer"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getOntoInfo.R
\name{getOntoInfo}
\alias{getOntoInfo}
\title{Query Ontology Lookup Service (OLS)}
\usage{
getOntoInfo(query, ontology = "", exact = FALSE, rows = 20)
}
\arguments{
\item{query}{A character (1) containing the search query, either a term
label or term id.}

\item{ontology}{A character vector defining the ontology to be queried. 
Default is the empty character, to search all ontologies.}

\item{exact}{A logical (1) defining if OLS search is restricted to exact
matches. Defaults is `FALSE`.}

\item{rows}{An integer (1) defining the number of query returns. 
Default is 20L. Maximum number of values returned by the server is 1000.}
}
\value{
A tibble containing ontology term label and description
}
\description{
Extract identical or similar ontology terms across different ontologies
}
\examples{
getOntoInfo("NCIT:C4872")
getOntoInfo("NCIT:C4872", ontology = c("EFO", "MONDO"))
getOntoInfo("Skin Infection")
getOntoInfo("Sitagliptin", ontology = c("Chebi", "apple"))

## Multiple query values
getOntoInfo("plasma,membrane")
getOntoInfo(c("plasma", "membrane"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{merge_vectors}
\alias{merge_vectors}
\title{Custom function to merge vectors}
\usage{
merge_vectors(base, update, sep = ":", delim = ";")
}
\arguments{
\item{base}{A character. A space-holder version of the key:value 
concatenates (e.g., `column1:NA;column2:NA;column3:NA`)}

\item{update}{A character. The target string to be compared and filled with 
`base` if there is missing pairs. (e.g., `column1:value1;column3:value3`)}

\item{sep}{A character string to separate the column name and value. 
Default is `:`}

\item{delim}{A character string to separate the column:value pairs. 
Default is `;`}
}
\value{
A character updated the target string (`update`) to follow the
reference string (`base`).
}
\description{
This function is designed for a group of, collapsible metadata attributes
(e.g., 'biomarker' for curatedMetagenomicData).
}
\examples{
x <- "color:NA;shape:NA;size:NA"
y <- "color:green;size:large"
merge_vectors(x, y)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getMetadata.R
\name{getMetadata}
\alias{getMetadata}
\title{Download a harmonized metadata table}
\usage{
getMetadata(database = NULL, load = TRUE)
}
\arguments{
\item{database}{Name of the database to get the metadata from. Currently, 
there are two available options.
\itemize{
    \item \code{cMD} : metadata for curatedMetagenomicData
    \item \code{cBioPortal} : metadata for cBioPortalData
}}

\item{load}{Default is \code{TRUE}. If it's set to \code{FALSE}, the 
metadata table is downloaded to cache but not loaded into memory.}
}
\value{
Curated metadata table or file cache location, if `load = FALSE`.
}
\description{
Download a harmonized metadata table
}
\examples{
cmd <- getMetadata("cMD")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ontoSummarize.R
\name{ontoSummarize}
\alias{ontoSummarize}
\title{Groups ontology terms by the child term of a provided "parent" they fall
under}
\usage{
ontoSummarize(parent, descendants, ontology)
}
\arguments{
\item{parent}{Character; Term to use as parent of summarized children}

\item{descendants}{Character vector; Terms to summarize as children of parent}

\item{ontology}{Character; Ontology database ID}
}
\value{
A dataframe containing the descendants summarized into groups. Name
of each group is the child of the parent that the descendants are grouped
under. Both IDs and labels of the ontology terms are provided.
}
\description{
Groups ontology terms by the child term of a provided "parent" they fall
under
}
\examples{
ontology <- "ncit"
parent <- "NCIT:C17049"
descendants <- c("NCIT:C44265", "NCIT:C77811", "NCIT:C43856",
                 "NCIT:C43672", "NCIT:C2991", "NCIT:C43860")
ontoSummarize(parent, descendants, ontology)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/spreadMeta.R
\name{spreadMeta}
\alias{spreadMeta}
\title{Manipulate metadata into a spread format}
\usage{
spreadMeta(meta, targetCol)
}
\arguments{
\item{meta}{A data frame. Harmonized metadata available through the
OmicsMLRepoR package. It should have the `package` column.}

\item{targetCol}{A character. The column name(s) to expand if present. 
If multiple columns are specified here, they should be separated by 
the `sep` and the column name and its value should be separated by the 
provided `delim`.}
}
\value{
A metadata table where the `targetCol` is updated to a long form (if it
is multi-valued attribute) or spread into multiple columns (if it is 
composite attribute).
}
\description{
This function speads gout multiple values per attribute (‘multi-valued’ 
attribute) or multiple features under a single generic attribute 
(‘composite’ attribute). Multi-valued attribute will return 'long' table, 
while composite attribute will return 'wide' table.
}
\examples{
data(mini_cmd2) # multi-valued attribute
data(mini_cmd3) # composite attribute
spreadMeta(mini_cmd2, "target_condition")
spreadMeta(mini_cmd3, "probing_pocket_depth")

data(mini_cbio)
trt_cols <- grep("^treatment_", colnames(mini_cbio), value = TRUE)
spreadMeta(mini_cbio, targetCol = trt_cols)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{get_ontologies}
\alias{get_ontologies}
\title{Extract ontology from the ontology term ids}
\usage{
get_ontologies(terms, delim = ":")
}
\arguments{
\item{terms}{A character vector}

\item{delim}{A character. Delimiter between ontology and its id.
Default is `:`.}
}
\value{
A character vector containing the ontology names of the input 
`terms`. The length of this is same as the `terms` input.
}
\description{
Extract ontology from the ontology term ids
}
\examples{
terms <- c("HP:0001824", "MONDO:0010200", "NCIT:C122328", "4471000175100")
get_ontologies(terms = terms)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/availableTerms.R
\name{availableTerms}
\alias{availableTerms}
\title{Extract all the terms used in a quired attribute/column}
\usage{
availableTerms(attribute, db = "cMD")
}
\arguments{
\item{attribute}{A character (1). Name of the attribute/column you want to 
extract the terms used under.}

\item{db}{A character(1). Currently, `cMD` (curatedMetagenomicData) is only
supported.}
}
\value{
A data frame with two columns - existing values under the quried
attribute (`allowedvalues` column) and their ontology term id (`ontology`
column).
}
\description{
Extract all the terms used in a quired attribute/column
}
\examples{
availableTerms("age_group")
availableTerms("disease")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/spreadMeta.R
\name{getLongMetaTb}
\alias{getLongMetaTb}
\title{Expands metadata with multiple values belong to a same attribute}
\usage{
getLongMetaTb(meta, targetCol = NULL, delim = NULL)
}
\arguments{
\item{meta}{A data frame. Each column (and associated `ontology_term_id`
column) should use the same delimiter to separate multiple, same-numbered
values.}

\item{targetCol}{A character. The column name(s) to expand if present. 
If multiple columns are specified here, they should be separated by 
the `sep` and the column name and its value should be separated by the 
provided `delim`.}

\item{delim}{Optional. A character (1) of a delimiter used to separate 
multiple values in the metadata table.}
}
\value{
A data frame of metadata expanded so that each individual treatment 
has its own row.
}
\description{
Same as the `getWideMetaTb` function, this function accepts single
target column (`targetCol`). The target columns (and linked, accessory
columns) should have the same number of elements separated by the `delim`, 
and the multiple values for each column belongs to the same column/
attribute/field, i.e., no additional column name is required/provided.
}
\examples{
data(mini_cmd)
lmeta <- getLongMetaTb(mini_cmd, "hla")
dim(mini_cmd) 
dim(lmeta) 

data(mini_cmd2)
lmeta2 <- getLongMetaTb(mini_cmd2, "target_condition")
head(lmeta2, 3)

data(mini_cbio)
trt_cols <- grep("^treatment_", colnames(mini_cbio), value = TRUE)
lmeta3 <- getLongMetaTb(mini_cbio, targetCol = trt_cols)

short_tb <- data.frame(
    ind = c("A", "B", "C", "D", "E"),
    aval = c("cat;dog", "chicken", "horse", "frog;pig", "snake"),
    cval = c(1, NA, 3, 4, 5),
    bval = c("red;blue", "yellow", "NA", "green;NA", "brown"))
    
getLongMetaTb(short_tb, c("aval", "bval"), delim = ";")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/OmicsMLRepoR.R
\name{OmicsMLRepoR}
\alias{OmicsMLRepoR}
\title{OmicsMLRepoR: A package for browsing harmonized metadata through ontology}
\description{
The OmicsMLRepoR package provides functions to browse the harmonized 
metadata created under the OmicsMLRepo project. It supports data 
navigation if the metadata incorporates ontology.
}
\section{Key Functions}{

\itemize{
  \item \code{\link{getMetadata}}: Download a harmonized metadata table
  \item \code{\link{tree_filter}}: Find samples including the queried 
  terms and their descendants
}
}

\section{Additional Information}{

For more detailed information, see the vignette:
\code{vignette("Quickstart", package = "OmicsMLRepoR")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{mini_cbio}
\alias{mini_cbio}
\title{A subset of cBioPortalData metadata}
\format{
A data frame with 10 samples and 9 columns ('curation_id',
'acronym', 'acronym_ontology_term_id', 'sex', 'package', 'treatment_name',
'treatment_name_ontology_term_id', 'treatment_type', 
'treatment_type_ontology_term_id')
}
\usage{
mini_cbio
}
\description{
A subset of curated version of cBioPortal's clinical metadata.
}
\author{
Sehyun Oh \email{shbrief@gmail.com}
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{mini_cmd}
\alias{mini_cmd}
\title{A subset of cMD metadata}
\format{
A data frame with 200 samples and 3 columns ('curation_id',
'hla', and 'package')
}
\usage{
mini_cmd
}
\description{
A subset of curated version of `sampleMetadata` from the 
curatedMetagenomicData (cMD, ver.3.8.0) package.
}
\author{
Sehyun Oh \email{shbrief@gmail.com}
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/spreadMeta.R
\name{getWideMetaTb}
\alias{getWideMetaTb}
\title{Create individual columns for different attributes stored in one column}
\usage{
getWideMetaTb(meta, targetCol = NULL, sep = ":", delim = "<;>", remove = TRUE)
}
\arguments{
\item{meta}{A data frame.}

\item{targetCol}{A character. The column name(s) to expand if present. 
If multiple columns are specified here, they should be separated by 
the `sep` and the column name and its value should be separated by the 
provided `delim`.}

\item{sep}{A character (1). Delimiter used to concatenate column name 
and its value. Default is double colons, `:`.}

\item{delim}{A character(1). Separator used between values. Default `<;>`.}

\item{remove}{If `TRUE`, remove input columns from output data frame.}
}
\value{
A data frame where the contents under `targetCol` is split into
individual columns in an alphabetical order. Data type of the expanded 
columns is all character.
}
\description{
The values stored in one column should include their potential column
names to use this function.
}
\examples{
## Narrow-table example
narrow_tb <- data.frame(fruit = c("apple", "banana", "pear", "watermelon", 
                                  "grape"), 
                        feature = c("color:red;shape:round;size:medium", 
                                    "color:yellow;shape:long;size:medium",
                                    "color:brown;shape:NA;size:NA",
                                    "color:green;shape:round;size:large",
                                    "color:purple;shape:NA;size:small"))
getWideMetaTb(narrow_tb, targetCol = "feature", sep = ":", delim = ";")

## Narrow-table example with missing columns
narrow_tb2 <- data.frame(fruit = c("apple", "banana", "pear", 
                                   "watermelon", "grape"), 
                        feature = c("color:red;shape:round;size:medium", 
                                    "color:yellow;shape:long;size:medium",
                                    NA,
                                    "color:green;size:large",
                                    "color:purple;shape:NA;size:small"))
getWideMetaTb(narrow_tb2, targetCol = "feature", sep = ":", delim = ";")

## Subset of cMD metadata
data(mini_cmd3)
wtb <- getWideMetaTb(mini_cmd3, targetCol = "probing_pocket_depth")
head(wtb)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gatherMeta.R
\name{getShortMetaTb}
\alias{getShortMetaTb}
\title{Compresses expanded metadata columns to one row per sample}
\usage{
getShortMetaTb(meta, idCols = NULL, targetCol = NULL, delim = "<;>")
}
\arguments{
\item{meta}{A data frame with expanded treatment columns.}

\item{idCols}{Optional. A character vector of columns that identify 
single samples, such as 'curation_id' and 'sampleId'. Defaults to 
standard ID columns.}

\item{targetCol}{Optional. A character vector of columns to compress if 
present. Default is names of all cBioPortal treatment-related columns.}

\item{delim}{Optional. A delimiter string. Default is `<;>`.}
}
\value{
A data frame where each sample gets a single row
}
\description{
Compresses expanded metadata columns to one row per sample
}
\examples{
data(mini_cmd)
lmeta <- getLongMetaTb(mini_cmd, "hla")
res <- getShortMetaTb(lmeta, targetCol = "hla")
dim(res) # 200 x 3 table

long_tb <- data.frame(ind = c("A", "A", "B", "C", "D", "D", "E"),
                      aval = c("cat", "dog", "chicken", "horse", 
                               "frog", "pig", "snake"),
                      cval = c(1, 1, NA, 3, 4, 4, 5),
                      bval = c("red", "blue", "yellow", NA, "green", 
                               NA, "brown"))
getShortMetaTb(long_tb, idCols = "ind", targetCol = c("aval", "bval"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{sample_metadata}
\alias{sample_metadata}
\title{sample_metadata}
\format{
A data frame with 4 rows and 7 columns
}
\usage{
sample_metadata
}
\description{
A small data table to demonstrating the data reshaping 
functions in OmicsMLRepoR.
}
\author{
Sehyun Oh \email{shbrief@gmail.com}
}
\keyword{data}
